import { BootstrapCheckBox } from './../index';
import { BootstrapCheckBoxStyleMode } from './../index';
import { AfterViewInit, ElementRef, OnInit, OnChanges, OnDestroy, SimpleChanges, EventEmitter } from '@angular/core';
import { BaseElement } from './smart.element';
import * as i0 from "@angular/core";
export { BootstrapCheckBoxStyleMode, ElementRenderMode } from './../index';
export { Smart } from './smart.element';
export { BootstrapCheckBox } from './../index';
export declare class BootstrapCheckBoxComponent extends BaseElement implements OnInit, AfterViewInit, OnDestroy, OnChanges {
    constructor(ref: ElementRef<BootstrapCheckBox>);
    private eventHandlers;
    nativeElement: BootstrapCheckBox;
    /** @description Creates the component on demand.
     * @param properties An optional object of properties, which will be added to the template binded ones.
     */
    createComponent(properties?: {}): any;
    /** @description Gets or sets the checked state of the element.  */
    get checked(): boolean;
    set checked(value: boolean);
    /** @description Enables or disables the element.  */
    get disabled(): boolean;
    set disabled(value: boolean);
    /** @description Gets or sets whether the element is in indeterminate state.  */
    get indeterminate(): boolean;
    set indeterminate(value: boolean);
    /** @description Sets the inner HTML of the element. */
    get innerHTML(): string;
    set innerHTML(value: string);
    /** @description Sets or gets the name attribute for the element. Name is used when submiting HTML forms. */
    get name(): string;
    set name(value: string);
    /** @description Gets or sets whether the element is required.  */
    get required(): boolean;
    set required(value: boolean);
    /** @description Sets or gets the style mode of the element. */
    get styleMode(): BootstrapCheckBoxStyleMode | string;
    set styleMode(value: BootstrapCheckBoxStyleMode | string);
    /** @description Change event is triggered when the value of the checkbox is changed.
    *  @param event. The custom event. 	*/
    onChange: EventEmitter<CustomEvent>;
    /** @description Toggles the checkbox
    */
    toggle(): void;
    get isRendered(): boolean;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    /** @description Add event listeners. */
    private listen;
    /** @description Remove event listeners. */
    private unlisten;
    static ɵfac: i0.ɵɵFactoryDeclaration<BootstrapCheckBoxComponent, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BootstrapCheckBoxComponent, "bootstrap-check-box, [bootstrap-check-box]", ["bootstrap-check-box"], { "checked": "checked"; "disabled": "disabled"; "indeterminate": "indeterminate"; "innerHTML": "innerHTML"; "name": "name"; "required": "required"; "styleMode": "styleMode"; }, { "onChange": "onChange"; }, never>;
}
